<?php

namespace Drupal\custom_main\Form;

use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\HtmlCommand;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormBuilderInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;

class ExampleForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'example_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form['text'] = [
      '#type' => 'textfield',
      '#title' => 'Text',
    ];

    $form['submit'] = [
      '#type' => 'submit',
      '#value' => 'Submit',
      '#id' => 'submit-my-form',
      '#ajax' => [
        'callback' => '::ajaxSubmit',
        'url' => Url::fromRoute('<front>'),
        'options' => [
          'query' => [
            FormBuilderInterface::AJAX_FORM_REQUEST => 1,
          ],
        ],
      ],
    ];

    $form['date'] = [
      '#markup' => '<div>Submit time: <div id="date"></div></div>',
    ];

    $form['#token'] = FALSE;

    return $form;
  }

  /**
   * Ajax callback.
   */
  public function ajaxSubmit(array &$form, FormStateInterface $form_state) {
    $response = new AjaxResponse();
    $response->addCommand(new HtmlCommand('#date', date('r')));
    return $response;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->messenger()->addMessage('ok');
  }

}
